//  Copyright (C) 2003 Koji Tsukada and Satoru Takabayashi
//      All rights reserved.
//      This is free software with ABSOLUTELY NO WARRANTY.
//
//  You can redistribute it and/or modify it under the terms of
//  the GNU General Public License version 2.

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;
using System.Drawing.Imaging;


namespace FaceIcon
{
	/// <summary>
	/// ConfigForm ̊Tv̐łB
	/// </summary>
	/// 
	public class ConfigForm : System.Windows.Forms.Form
	{
		#region Definition of Windows.Forms
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox textBox5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.Label labelHere1;
		private System.Windows.Forms.Label labelHere2;
		private System.Windows.Forms.TextBox textBox6;
		private System.Windows.Forms.Label label10;
		#endregion

		UserProfile userProfile;
		TargetProfile targetProfile;
		Config config;
		string sourceIconPath;
		IconForm iconForm ;
		
		public ConfigForm(Config config, UserProfile userProfile, TargetProfile targetProfile)
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();


			this.config = config;
			if (targetProfile == null) 
			{
				this.targetProfile = new TargetProfile();
				this.targetProfile.Name = "RcY";
				this.targetProfile.Address = "taro.yamada@example.jp";
				this.targetProfile.MobileAddress = "";
			}
			else
			{
				this.targetProfile = targetProfile;
				this.Text = "ݒύX܂";
				label1.Text = "ݒύX܂";
			}

			if (userProfile == null) 
			{
				this.userProfile = new UserProfile();
				this.userProfile.Name = "Ȃ̖O";
				this.userProfile.Address = "Ȃ̃[AhX";
				this.userProfile.SmtpHost = "mail.example.jp";
			} 
			else
			{
				this.userProfile = userProfile;
				
			}

			textBox1.Text = this.targetProfile.Name;
			textBox2.Text = this.targetProfile.Address;
			textBox3.Text = this.userProfile.Name;
			textBox4.Text = this.userProfile.Address;
			textBox5.Text = this.userProfile.SmtpHost;
			textBox6.Text = this.targetProfile.MobileAddress;

			toolTip1.AutomaticDelay = 50;
			toolTip1.ShowAlways = true;

		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void ConfigForm_Load(object sender, System.EventArgs e)
		{
			if (targetProfile.IconPath != null)
				LoadFaceIcon(targetProfile.IconPath);
		}

		private void OpenIconForm()
		{
			if(pictureBox1.Image != null)
				iconForm = new IconForm(pictureBox1.Image);
			else
				iconForm = new IconForm();

			this.Visible = false;
			iconForm.ShowDialog();
			if(iconForm.DialogResult == DialogResult.OK && iconForm.FaceIcon != null)
			{
				pictureBox1.Image = iconForm.FaceIcon.ToBitmap();
				this.Icon = iconForm.FaceIcon;
				labelHere1.Visible = false;
				labelHere2.Visible = false;
			}
			this.Visible = true;
		}

		private void PrepareDirectories ()
		{
			Directory.CreateDirectory(config.IconDirectory);
		}

		private void LoadFaceIcon (string fileName)
		{
			try 
			{
				Util.LoadImage(pictureBox1, fileName);
				Util.LoadIcon(this, fileName);
				sourceIconPath = fileName;
				labelHere1.Visible = false;
				labelHere2.Visible = false;
			}
			catch (Exception e)
			{
				MessageBox.Show("ACR̓ǂݍ݂Ɏs܂" + "\n" + e.Message);
			}
		}

		private void SaveIcon ()
		{
			UtilBitmap util;
			try
			{
				targetProfile.IconPath = config.IconDirectory + "\\" + targetProfile.Name + ".ico";
				util = new UtilBitmap(targetProfile.IconPath, this.Icon.ToBitmap());
				util.CreateBitmapIcon();
			}
			catch(Exception e)
			{
				MessageBox.Show(e.ToString());
			}
			
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ConfigForm));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.textBox5 = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.labelHere2 = new System.Windows.Forms.Label();
			this.labelHere1 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.textBox6 = new System.Windows.Forms.TextBox();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.AllowDrop = true;
			this.pictureBox1.BackColor = System.Drawing.Color.White;
			this.pictureBox1.Location = new System.Drawing.Point(16, 80);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(48, 48);
			this.pictureBox1.TabIndex = 3;
			this.pictureBox1.TabStop = false;
			this.toolTip1.SetToolTip(this.pictureBox1, "ɃACRhbOAhhbvĂo^ł܂B");
			this.pictureBox1.Click += new System.EventHandler(this.pictureBox1_Click);
			this.pictureBox1.DragEnter += new System.Windows.Forms.DragEventHandler(this.pictureBox1_DragEnter);
			this.pictureBox1.DragDrop += new System.Windows.Forms.DragEventHandler(this.pictureBox1_DragDrop);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("MS UI Gothic", 13F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label1.Location = new System.Drawing.Point(24, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(240, 32);
			this.label1.TabIndex = 4;
			this.label1.Text = "fXNgbvɊACR܂";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label2.Location = new System.Drawing.Point(96, 112);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "O";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label3.Location = new System.Drawing.Point(96, 152);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(72, 14);
			this.label3.TabIndex = 6;
			this.label3.Text = "[AhX";
			// 
			// textBox1
			// 
			this.textBox1.BackColor = System.Drawing.Color.White;
			this.textBox1.Location = new System.Drawing.Point(96, 128);
			this.textBox1.Name = "textBox1";
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "";
			// 
			// textBox2
			// 
			this.textBox2.BackColor = System.Drawing.Color.White;
			this.textBox2.Location = new System.Drawing.Point(96, 168);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(168, 19);
			this.textBox2.TabIndex = 2;
			this.textBox2.Text = "";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.textBox5,
																					this.label6,
																					this.label5,
																					this.textBox3,
																					this.textBox4,
																					this.label4,
																					this.label8});
			this.groupBox1.Location = new System.Drawing.Point(8, 248);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(272, 160);
			this.groupBox1.TabIndex = 4;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Ȃ̐ݒ";
			// 
			// textBox5
			// 
			this.textBox5.BackColor = System.Drawing.Color.White;
			this.textBox5.Location = new System.Drawing.Point(88, 128);
			this.textBox5.Name = "textBox5";
			this.textBox5.Size = new System.Drawing.Size(168, 19);
			this.textBox5.TabIndex = 7;
			this.textBox5.Text = "";
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label6.Location = new System.Drawing.Point(8, 128);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(72, 14);
			this.label6.TabIndex = 14;
			this.label6.Text = "SMTPT[o";
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label5.Location = new System.Drawing.Point(48, 64);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(32, 16);
			this.label5.TabIndex = 10;
			this.label5.Text = "O";
			// 
			// textBox3
			// 
			this.textBox3.BackColor = System.Drawing.Color.White;
			this.textBox3.Location = new System.Drawing.Point(88, 64);
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(104, 19);
			this.textBox3.TabIndex = 5;
			this.textBox3.Text = "";
			// 
			// textBox4
			// 
			this.textBox4.BackColor = System.Drawing.Color.White;
			this.textBox4.Location = new System.Drawing.Point(88, 96);
			this.textBox4.Name = "textBox4";
			this.textBox4.Size = new System.Drawing.Size(168, 19);
			this.textBox4.TabIndex = 6;
			this.textBox4.Text = "";
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label4.Location = new System.Drawing.Point(8, 96);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(72, 14);
			this.label4.TabIndex = 11;
			this.label4.Text = "[AhX";
			// 
			// label8
			// 
			this.label8.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label8.Location = new System.Drawing.Point(16, 24);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(248, 32);
			this.label8.TabIndex = 11;
			this.label8.Text = "Ȃ̖OA[AhXASMTPT[oݒ肵܂BSMTPT[o̓[̑MɎg܂B";
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label7.Location = new System.Drawing.Point(24, 24);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(240, 32);
			this.label7.TabIndex = 10;
			this.label7.Text = "t@C𑗂鑊̃ACRƖOA[AhXݒ肵܂B";
			// 
			// button1
			// 
			this.button1.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.button1.Location = new System.Drawing.Point(64, 416);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(64, 24);
			this.button1.TabIndex = 8;
			this.button1.Text = "OK";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(160, 416);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(64, 24);
			this.button2.TabIndex = 9;
			this.button2.Text = "LZ";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.labelHere2,
																					this.labelHere1,
																					this.label7,
																					this.label9,
																					this.label10,
																					this.pictureBox1});
			this.groupBox2.Location = new System.Drawing.Point(8, 48);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(272, 192);
			this.groupBox2.TabIndex = 0;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "̐ݒ";
			// 
			// labelHere2
			// 
			this.labelHere2.AllowDrop = true;
			this.labelHere2.BackColor = System.Drawing.Color.White;
			this.labelHere2.Location = new System.Drawing.Point(16, 104);
			this.labelHere2.Name = "labelHere2";
			this.labelHere2.Size = new System.Drawing.Size(48, 16);
			this.labelHere2.TabIndex = 19;
			this.labelHere2.Text = "NbN";
			this.labelHere2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.labelHere2.Click += new System.EventHandler(this.labelHere2_Click);
			this.labelHere2.DragEnter += new System.Windows.Forms.DragEventHandler(this.labelHere2_DragEnter);
			this.labelHere2.DragDrop += new System.Windows.Forms.DragEventHandler(this.labelHere2_DragDrop);
			// 
			// labelHere1
			// 
			this.labelHere1.AllowDrop = true;
			this.labelHere1.BackColor = System.Drawing.Color.White;
			this.labelHere1.Location = new System.Drawing.Point(24, 88);
			this.labelHere1.Name = "labelHere1";
			this.labelHere1.Size = new System.Drawing.Size(32, 16);
			this.labelHere1.TabIndex = 18;
			this.labelHere1.Text = "";
			this.labelHere1.Click += new System.EventHandler(this.labelHere1_Click);
			this.labelHere1.DragEnter += new System.Windows.Forms.DragEventHandler(this.labelHere1_DragEnter);
			this.labelHere1.DragDrop += new System.Windows.Forms.DragEventHandler(this.labelHere1_DragDrop);
			// 
			// label9
			// 
			this.label9.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label9.Location = new System.Drawing.Point(16, 64);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(48, 16);
			this.label9.TabIndex = 11;
			this.label9.Text = "ACR";
			// 
			// label10
			// 
			this.label10.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label10.Location = new System.Drawing.Point(88, 144);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(144, 14);
			this.label10.TabIndex = 15;
			this.label10.Text = "gѓdb̃[AhX";
			// 
			// textBox6
			// 
			this.textBox6.BackColor = System.Drawing.Color.White;
			this.textBox6.Location = new System.Drawing.Point(96, 208);
			this.textBox6.Name = "textBox6";
			this.textBox6.Size = new System.Drawing.Size(168, 19);
			this.textBox6.TabIndex = 3;
			this.textBox6.Text = "";
			// 
			// ConfigForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(286, 444);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.textBox6,
																		  this.button2,
																		  this.button1,
																		  this.groupBox1,
																		  this.textBox2,
																		  this.textBox1,
																		  this.label3,
																		  this.label2,
																		  this.label1,
																		  this.groupBox2});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ConfigForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "fXNgbvɊACR܂";
			this.Load += new System.EventHandler(this.ConfigForm_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods for Checking Buttons
		private void pictureBox1_Click(object sender, System.EventArgs e)
		{
			OpenIconForm();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			targetProfile.Name = textBox1.Text;
			targetProfile.Address = textBox2.Text;
			targetProfile.MobileAddress = textBox6.Text;
			userProfile.Name = textBox3.Text;
			userProfile.Address = textBox4.Text;		
			userProfile.SmtpHost = textBox5.Text;

			PrepareDirectories();
			SaveIcon();
			userProfile.Save(config);
			targetProfile.Save(config);
			this.Close();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void labelHere1_Click(object sender, System.EventArgs e)
		{
			OpenIconForm();
		}

		private void labelHere2_Click(object sender, System.EventArgs e)
		{
			OpenIconForm();
		}
		#endregion

		#region Drag&Drop Setting
		private void pictureBox1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			if (e.Data.GetDataPresent(DataFormats.FileDrop)) 
				e.Effect = DragDropEffects.Copy;
			else
				e.Effect = DragDropEffects.None;
		}
		private void labelHere1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			if (e.Data.GetDataPresent(DataFormats.FileDrop)) 
				e.Effect = DragDropEffects.Copy;
			else
				e.Effect = DragDropEffects.None;
		}

		private void labelHere2_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			if (e.Data.GetDataPresent(DataFormats.FileDrop)) 
				e.Effect = DragDropEffects.Copy;
			else
				e.Effect = DragDropEffects.None;
		}

		private void pictureBox1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			string[] filenames = (string[])e.Data.GetData(DataFormats.FileDrop);
			if (filenames.Length > 1) 
				MessageBox.Show("t@C͂ЂƂhbOAhhbvĂ");
			else 
				LoadFaceIcon(filenames[0]);
		}
		private void labelHere1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			string[] filenames = (string[])e.Data.GetData(DataFormats.FileDrop);
			if (filenames.Length > 1) 
				MessageBox.Show("t@C͂ЂƂhbOAhhbvĂ");
			else 
				LoadFaceIcon(filenames[0]);
		}

		private void labelHere2_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			string[] filenames = (string[])e.Data.GetData(DataFormats.FileDrop);
			if (filenames.Length > 1) 
				MessageBox.Show("t@C͂ЂƂhbOAhhbvĂ");
			else 
				LoadFaceIcon(filenames[0]);
		}
		#endregion
	}
}
