//  Copyright (C) 2003 Koji Tsukada and Satoru Takabayashi
//      All rights reserved.
//      This is free software with ABSOLUTELY NO WARRANTY.
//
//  You can redistribute it and/or modify it under the terms of
//  the GNU General Public License version 2.

using System;
using System.Net.Sockets;
using System.Net;
using System.Text;
using System.Windows.Forms;
using System.Web.Mail; 


class MailSenderException : System.Exception {}

namespace FaceIcon
{
	/// <summary>
	/// MailSender ̊Tv̐łB
	/// </summary>
	public class MailSender
	{
		string hostName;
		int portNumber = 25;
        
		public MailSender(string hostName)
		{
			this.hostName = hostName;
		}

		public void Send(MailMessage mail)
		{
			string encodedMail = EncodeMail(mail);
			MessageBox.Show(encodedMail);

			return;

			TcpClient client = new TcpClient();
			client.Connect(hostName, portNumber);
			NetworkStream stream = client.GetStream();

			SendCommand(client, stream, null, 220);
			SendCommand(client, stream, "EHLO " + Dns.GetHostName(), 250);
			SendCommand(client, stream, "MAIL FROM: <" + mail.From + ">", 250);
			SendCommand(client, stream, "RCPT TO: <" + mail.To + ">", 250);
			SendCommand(client, stream, "DATA", 354);
		
			string[] lines = mail.Body.Split('\n');
			for (int i = 0; i < lines.Length; i++)
			{
				string line = lines[i] + "\n";
				if (line[0] == '.') 
				{
					line = "." + line;
				}
				Print(stream, line);
			}
			SendCommand(client, stream, ".", 250);
			SendCommand(client, stream, "quit", 221);
			client.Close();
		}

		private string ContentType(MailMessage mail)
		{
			if (mail.Attachments.Count == 0)
				return "text/plain; " + mail.BodyEncoding.BodyName;
			else
				return "mime multipart";
		}

		private string Subject(MailMessage mail)
		{
			Encoding currentEncoding = Encoding.Default;
			Encoding bodyEncoding = Encoding.GetEncoding(currentEncoding.BodyName);

			mail.Subject = "";
			byte[] data = Encoding.Convert(currentEncoding,	bodyEncoding, currentEncoding.GetBytes(mail.Subject));
			//  ->  =?iso-2022-jp?B?GyRCJCIkJCQmJCgkKhsoQg==?=
			string encodedSubject = 
				"=?" + bodyEncoding.BodyName + "?B?" + Convert.ToBase64String(data) + "=?=";
			return encodedSubject;
		}

		private string ToHex(byte[] data)
		{
			string hexString = "";
			for (int i = 0; i < data.Length; i++) 
			{
				hexString += data[i].ToString("x") + " ";
			}
			return hexString;
		}

		private string EncodeMail(MailMessage mail)
		{
			string encodedMail = "";
			encodedMail += GenerateHeader(mail);
			return encodedMail;
		}

		private string GenerateHeader(MailMessage mail)
		{
			string header = "";
			header += "To: " + mail.To + "\r\n";
			header += "From: " + mail.From + "\r\n";
			header += "Content-Type: " + ContentType(mail) + "\r\n";	
			header += "Subject: " + Subject(mail) + "\r\n";
			header += "Mime-Version: 1.0" + "\r\n";
			header += "Content-Transfer-Encoding: 7bit" + "\r\n";
			header += "Content-Type: Multipart/Mixed;" + "\r\n";
			header += "    boundary=\"--xxx--\"" + "\r\n";
			return header;
		}

		private void Print(NetworkStream stream, string s)
		{
			Byte[] data = Encoding.ASCII.GetBytes(s);
			stream.Write(data, 0, data.Length);
		}

		private string SendCommand(TcpClient client, NetworkStream stream, string command, int code)
		{
			if (command != null) 
				Print(stream, command + "\r\n");

			int len = client.ReceiveBufferSize;
			byte[] buf = new byte[len];
			stream.Read(buf, 0, len);
			string line = Encoding.ASCII.GetString(buf);
			int returnCode = int.Parse(Encoding.ASCII.GetString(buf, 0, 3));

			if (code == returnCode) 
				return line;
			else
				throw(new MailSenderException());
		}
	}
}
