//  Copyright (C) 2003 Koji Tsukada and Satoru Takabayashi
//      All rights reserved.
//      This is free software with ABSOLUTELY NO WARRANTY.
//
//  You can redistribute it and/or modify it under the terms of
//  the GNU General Public License version 2.

using System;
using System.Windows.Forms;
using System.IO;
using System.Drawing;
using IWshRuntimeLibrary;


namespace FaceIcon
{

	/// <summary>
	/// Util ̊Tv̐łB
	/// </summary>
	public class Util
	{
		public static void LoadImage(PictureBox pictureBox, string fileName)
		{
			// Ensure that fileName is closed to avoid IOException 	while overwriting a file.
			using (FileStream stream = new FileStream(fileName, FileMode.Open, FileAccess.Read, FileShare.Read))
			{
				pictureBox.Image = new Bitmap(stream);
				//pictureBox.Image = Bitmap.FromFile(fileName);
			}
		}

		public static void LoadIcon(Form form, string fileName)
		{
			// Ensure that fileName is closed to avoid IOException while overwriting a file.
			using (FileStream stream = new FileStream(fileName, FileMode.Open, FileAccess.Read, FileShare.Read))
			{
				form.Icon = new Icon(stream);
			}
		}

		public static void CreateShortcut(string targetPath, 
			string arguments,
			string shortcutPath, 
			string workPath,
			string iconPath,
			string description)
		{

			IWshShell_Class theShell = new IWshShell_Class();  
			IWshShortcut_Class shortcut = 
				(IWshShortcut_Class)theShell.CreateShortcut(shortcutPath);

			if (targetPath != null)
				shortcut.TargetPath = targetPath;
			if (arguments != null)
				shortcut.Arguments = arguments;
			if (workPath != null)
				shortcut.WorkingDirectory = workPath;
			if (iconPath != null)
				shortcut.IconLocation = iconPath;
			if (description != null)
				shortcut.Description = description;
			shortcut.Save();
		}



	}
}
